#include <zephyr.h>
#include <kernel.h>
#include <gpio.h>

#define PIN 16

struct device *gpio_dev;
struct gpio_callback gpio_cb;

u32_t gpio_counter = 0;

void gpio_handler(struct device *port, struct gpio_callback *cb, u32_t pins) {
    gpio_counter++;
}

void main() {
    gpio_dev = device_get_binding("GPIO_0");
    if (gpio_dev == NULL) {
        printk("Unable to get GPIO device\n");
        return;
    }

    int err;
    err = gpio_pin_configure(gpio_dev, PIN, GPIO_DIR_IN | GPIO_INT | GPIO_INT_ACTIVE_HIGH | GPIO_INT_EDGE);
    if (err) {
        return;
    }

    gpio_init_callback(&gpio_cb, gpio_handler, 0xffffffff);

    gpio_add_callback(gpio_dev, &gpio_cb);

    gpio_pin_enable_callback(gpio_dev, PIN);

    while (1) {
        printk("%d\n", gpio_counter);
        k_sleep(100);
    }
    
}